function VBIContextMenuLibray(R, that, dataUtilityLib) {
    if (!that)
        that = {};
    var self = this;
    self.R = R;
    self.dataUtilityLib = dataUtilityLib;
    self.componentObject = that;
    agGrid.LicenseManager.setLicenseKey('Visual_BI_Solutions_Visual_BI_Extensions_for_SAP_BusinessObjects_Design_Studio_5Devs_100OEM_28_April_2018__MTUyNDg3MDAwMDAwMA==e5939d26c094f0dcda378541d9a5e369');
    self.VBIContextMenuData = new VBIContextMenuDataLib(this);
    if (!that.contextMenuDrillDownFilter) {
        that.contextMenuDrillDownFilter = {
            filterItems: [],
            filterdDimesions: {},

        };
    }
    sap.zen.designmode === undefined ? self.browser = true : self.browser = false;
}
VBIContextMenuLibray.prototype.attachStyle = function(self) {
    if (!self) {
        self = this;
    }
    var rightOffset=10;
    if(self.componentObject.exportingsymbolenabled)
    {
        if(self.componentObject.exportingsymbolenabled() && self.componentObject.exportingsymbolalign()=='right' && self.componentObject.exportingsymbolverticalalign()=='top' && !self.componentObject.enableContextMenu() && !self.componentObject.enableMoreActionsButton())
        {
            rightOffset=rightOffset+25;
        }
    }
    var propertyStyleMapList = [{
            'componentProperty': 'actionButtonsBackground',
            'cssSelector': '.vbi-action-buttons .fa',
            'cssProperty': 'background',
            'defaultValue': 'rgba(255, 255, 255, 0)'
    }, {
            'componentProperty': 'actionButtonsColor',
            'cssSelector': '.vbi-action-buttons .fa',
            'cssProperty': 'color'
    }, {
            'componentProperty': 'actionButtonsSize',
            'cssSelector': '.vbi-action-buttons .fa',
            'cssProperty': 'font-size',
            'suffix': 'px'
    }, {
            'componentProperty': 'contextMenuFontSize',
            'cssSelector': '.context-menu-icon.context-menu-icon--fa,.context-menu-item',
            'cssProperty': 'font-size',
            'suffix': 'px'
    }, {
            'componentProperty': 'contextMenuFontSize',
            'cssSelector': '.context-contional-formating',
            'cssProperty': 'height',
            'suffix': 'px'
    }, {
            'componentProperty': 'contextMenuFontSize',
            'cssSelector': '.context-contional-formating',
            'cssProperty': 'width',
            'suffix': 'px'
    }, {
            'componentProperty': 'contextMenuFontColor',
            'cssSelector': '.context-menu-item',
            'cssProperty': 'color'
    }, {
            'componentProperty': 'contextMenuFontFamily',
            'cssSelector': '.context-menu-item',
            'cssProperty': 'font-family',
            'isImportant': true
    }
    , {
            'componentProperty': 'contextMenuHoverTextColor',
            'cssSelector': '.context-menu-item.context-menu-hover',
            'cssProperty': 'color'
    }, {
            'componentProperty': 'contextMenuBackgroundColor',
            'cssSelector': '.context-menu-item,.context-menu-list',
            'cssProperty': 'background'
    }, {
            'componentProperty': 'contextMenuHoverBackgroundColor',
            'cssSelector': '.context-menu-item.context-menu-hover',
            'cssProperty': 'background'
    }, {
            'componentProperty': 'contextMenuIconColor',
            'cssSelector': '.context-menu-icon.context-menu-icon--fa::before',
            'cssProperty': 'color'
    }, {
            'componentProperty': 'contextMenuHoverIconColor',
            'cssSelector': '.context-menu-icon.context-menu-icon--fa.context-menu-hover::before',
            'cssProperty': 'color'
    }, {
            'componentProperty': 'actionButtonsVerticalAlign',
            'cssSelector': '.vbi-action-buttons',
            formatter: function(originlValue) {
                if (originlValue == 'bottom') {
                    return 'top:auto!important;bottom:10px!important;';
                } else {
                    return 'top:8px!important;bottom:auto!important;';
                }
            }
    }, {
            'componentProperty': 'actionButtonsVerticalAlign',
            'cssSelector': '.vbi-context-filter-panel-layer',
            formatter: function(originlValue) {
                if (originlValue == 'bottom') {
                    return 'top:auto!important;bottom:37px!important;';
                } else {
                    return 'top:37px!important;bottom:auto!important;';
                }
            }
    },
        {
            'componentProperty': 'actionButtonsHorizontalAlign',
            'cssSelector': '.vbi-action-buttons',
            formatter: function(rightOffset,originlValue) {
                if (originlValue == 'left') {
                    return 'right:auto!important;left:10px!important;';
                } else {
                    return 'right:'+rightOffset+'px!important;left:auto!important;';
                }
            }.bind(null,rightOffset)
     },
        {
            'componentProperty': 'actionButtonsHorizontalAlign',
            'cssSelector': '.vbi-context-filter-panel-layer',
            formatter: function(originlValue) {
                if (originlValue == 'left') {
                    return 'right:auto!important;left:10px!important;';
                } else {
                    return 'right:10px!important;left:auto!important;';
                }
            }
    },{
            'componentProperty': 'contextMenuFontStyle',
            'cssSelector': '.context-menu-item',
             formatter: function(originlValue) {
                if (originlValue == 'bold') {
                    return 'font-weight:bold!important;';
                } else if(originlValue == 'italic') {
                    return 'font-style:italic!important;';
                }
                else if (originlValue == 'underline') {
                     return 'text-decoration:underline!important;';
                }
            }
    },{
            'componentProperty': 'actionButtonsVerticalAlign',
            'cssSelector': '.vbi-context-rank-layer',
            formatter: function(originlValue) {
                if (originlValue == 'bottom') {
                    return 'top:auto!important;bottom:37px!important;';
                } else {
                    return 'top:37px!important;bottom:auto!important;';
                }
            }
    },{
            'componentProperty': 'actionButtonsHorizontalAlign',
            'cssSelector': '.vbi-context-rank-layer',
            formatter: function(originlValue) {
                if (originlValue == 'left') {
                    return 'right:auto!important;left:10px!important;';
                } else {
                    return 'right:10px!important;left:auto!important;';
                }
            }
    }];
   
    constructCss(propertyStyleMapList, self.componentObject, true);
}
VBIContextMenuLibray.prototype.openContextMenu = function(component, event) {

    if (is_iPhone_or_iPad()) {
        event = event.originalEvent.touches[0];
    }
    component.contextMenu({
        x: event.clientX,
        y: event.clientY
    });

}
function is_iPhone_or_iPad() {
    return navigator.platform.match(/i(Phone|Pad)/i);
}
VBIContextMenuLibray.prototype.highchartsPostProcess=function(){
    var self=this;
    var component=self.componentObject.$();
        if (self.componentObject.lassoState) {
        var chart = isHighChart(component);
        if (chart) {
                chart.lasso = self.componentObject.lassoState;
        }
    }
    if (self.componentObject.displayTable) {
          self.VBIContextMenuData.displayData();
    }
}
VBIContextMenuLibray.prototype.maximizeComponent=function(maximizeClass,referenceComponent){
var css="."+maximizeClass+"{";
 if(referenceComponent.length!=0)
 {
     css+="height:"+referenceComponent.height()+"px!important;";
     css+="width:"+referenceComponent.width()+"px!important;";
     css+="top:"+referenceComponent.offset().top+"px!important;";
     css+="left:"+referenceComponent.offset().left+"px!important;";
 }
 else{
     css+="height:100%!important;";
     css+="width:100%!important;";
     css+="top:0!important;";
     css+="left:0!important;";
 }
 var styleTag=$('<style class='+maximizeClass+'_style>'+css+'</style>');
 var oldStyleElement=$('.'+maximizeClass+'_style');
 if(oldStyleElement.length>0);
 {
     oldStyleElement.remove();
 }
 $('body').append(styleTag);
}
VBIContextMenuLibray.prototype.attachContextMenu = function() {
    // return true;
    var self = this;
    var isContextEnabled = false;
    var componentObject=self.componentObject;
    if(!componentObject.contextMenuUniqueId)
    {
        componentObject.contextMenuUniqueId=_.uniqueId("context_");
    }
    self.uniqueId= componentObject.contextMenuUniqueId;
    var component = componentObject.$();
    var componetId = component.attr('id');
    var componentContainer = component.parent();
    var moreActionId = self.uniqueId+"_moreAction";
    var buttonContainerId =self.uniqueId+"_contextButtonContainer";
    var maximizeClass=self.uniqueId+"_maximizeClass";
    var maximizeRefrenceComponet={length:0};
    if(componentObject.chartMaximizePanel)
    {
        if(componentObject.chartMaximizePanel())
        {
            var maximizeRefrenceComponetDetail=sap.zen.Dispatcher.instance.getRootControlForComponentId(componentObject.chartMaximizePanel());
            if(maximizeRefrenceComponetDetail)
            {
                maximizeRefrenceComponet=$("#"+maximizeRefrenceComponetDetail.sId);
            }
        }
    }
    if(!componentObject.originalRuleTable && componentObject.ruletable)
    {
        componentObject.originalRuleTable=componentObject.ruletable();
    }
    if (self.componentObject.contextContainerId) {
        $('.' + self.componentObject.contextContainerId).remove();
    }
    self.componentObject.contextContainerId = buttonContainerId;
    try {
        var selectedContextMenuItems = JSON.parse(self.componentObject.contextMenuItems());
        var selectedItemList = _.filter(selectedContextMenuItems, function(object) {
            return object.enable;
        })
        self.selectedKeys = _.map(selectedItemList, function(object) {
            return object.key;
        })
    } catch (e) {
        self.selectedKeys = false;
    }
    var drillInfoIcon = $('<i class="fa fa-level-up" aria-hidden="true" data-toggle="tooltip" data-placement="top" title="DrillUp"></i>');
    var minimizeButton = $('<i class="fa fa-window-restore vbi-restore-chart" data-toggle="tooltip" data-placement="top" title="Restore Chart" aria-hidden="true"></i>');
    var maximizeButton = $('<i class="fa fa-window-maximize vbi-maximize-chart" data-toggle="tooltip" data-placement="top" title="Maximize Chart" aria-hidden="true"></i>');
    var moreActionsButton = $('<i class="fa fa-ellipsis-h vbi-more-actions" data-toggle="tooltip" data-placement="top" title="Action Menu" aria-hidden="true"></i>');
    var displayDataButton = $('<i class="fa fa-table vbi-display-data" data-toggle="tooltip" data-placement="top" title="Display Data" aria-hidden="true"></i>');
    var buttonContainer = $('<div class="vbi-action-buttons"></div>');
    buttonContainer.addClass(buttonContainerId);
    moreActionsButton.addClass(moreActionId);
    if (self.componentObject.contextMenuDrillDownFilter.filterItems.length != 0) {
        buttonContainer.append(drillInfoIcon);
    }
    if (componentObject.enableMaximizeButton() &&  $('.rui-panel').length===0) {
        buttonContainer.append(minimizeButton).append(maximizeButton);
    }
    if (componentObject.enableDisplayDataButton()) {
        buttonContainer.append(displayDataButton);
    }
    if (componentObject.enableMoreActionsButton()) {
        buttonContainer.append(moreActionsButton);
    }
    self.buttonContainer=buttonContainer;
    componentContainer.prepend(buttonContainer);
    self.attachStyle();
    minimizeButton.hide();
    if(!self.browser)
    {
        return;
    }
    if(component.hasClass('vbi-fullscreen'))
    {
       buttonContainer.toggleClass('context-z-index-60');
       maximizeButton.toggle();
       minimizeButton.toggle();
    }
    var isiPad = is_iPhone_or_iPad();
    var trigger = isiPad ? 'touchstart' : 'click';
    var contextTrigger = isiPad ? 'tochstart' : 'left';
    maximizeButton.add(minimizeButton).on(trigger, function() {
        component.toggleClass('vbi-fullscreen');
        componentContainer.toggleClass('vbi-fullscreen');
        component.toggleClass(maximizeClass);
        componentContainer.toggleClass(maximizeClass);
        self.maximizeComponent(maximizeClass,maximizeRefrenceComponet);
        buttonContainer.toggleClass('context-z-index-60');
        reflowChart(component);
        maximizeButton.toggle();
        minimizeButton.toggle();
    });
    if(maximizeRefrenceComponet.length!=0)
    {
        $(window).resize(function(){
            if(component.hasClass(maximizeClass))
              {self.maximizeComponent(maximizeClass,maximizeRefrenceComponet);}
        });
    }

    displayDataButton.on(trigger, function() {
        self.VBIContextMenuData.displayData();
    });
    self.drillInfoPane = false;
    drillInfoIcon.on(trigger, function() {
        if (!self.drillInfoPane)
            self.VBIContextMenuData.drillUpOneLevel();
    });
    drillInfoIcon.on('taphold', function(event) {
        self.drillInfoPane = true;
        self.VBIContextMenuData.filterInfoPane();
    });
    if (componentObject.enableMoreActionsButton()) {
        attachContextMenuToSelector('.' + moreActionId, contextTrigger, self);

    }
    if (componentObject.enableContextMenu()) {
        attachContextMenuToSelector('#' + componetId, 'right', self);
    }
    if (isiPad) {
        var openContextMenuCurried = self.R.curry(self.openContextMenu)(self.componentObject.$())
        if (self.componentObject.contextMenuiPadTrigger() == "onLongPress") {
            $.event.special.tap.tapholdThreshold = 300;
            $('#' + componetId).on('taphold', openContextMenuCurried)
        } else {
            $('#' + componetId).doubletap(openContextMenuCurried);
        }
    }
}

function attachContextMenuToSelector(selector, trigger, self, getItems) {
    $.contextMenu({
        selector: selector,
        trigger: trigger,

        build: function($trigger, e) {
            return {
                items: self.VBIContextMenuData.getContextMenuItems()
            }
        }

    })
}